import type { transport } from '../../client/type';
import { BridgeBasic } from '../Basic';
export declare enum ACTION {
    OPEN = "openResourcePicker",
    DISCARD = "discardResourcePicker",
    SELECTED = "resourcePickerSelected"
}
interface IResourcePickerConfig {
    title?: string;
    okBtnText?: string;
    type: 'Product' | 'Variant';
}
declare class ResourcePicker extends BridgeBasic {
    constructor(app: transport);
    open: (config?: IResourcePickerConfig) => void;
    cancel: () => void;
}
export declare function create(app: transport): ResourcePicker;
export {};
