import type { transport } from '../../client/type';
import { BridgeBasic } from '../Basic';
export declare enum ACTION {
    OPEN = "openUnstableResourcePicker",
    DISCARD = "discardUnstableResourcePicker",
    SELECTED = "unstableresourcePickerSelected"
}
interface ItemType {
    key: string;
    name: string;
    children?: ItemType & {
        parentKey: string;
    }[];
}
interface IResourcePickerConfig {
    title?: string;
    okBtnText?: string;
    items: ItemType[];
}
declare class UnstableResourcePicker extends BridgeBasic {
    constructor(app: transport);
    open: (config: IResourcePickerConfig) => void;
    cancel: () => void;
}
export declare function create(app: transport): UnstableResourcePicker;
export {};
