import { ACTION } from "../enum/ActionEnum";
export type appConfig = {
    appKey: string;
    debug?: boolean;
    host?: string;
    coincidentOrigin?: boolean;
};
export interface transport {
    localOrigin?: any;
    hostFrame?: any;
    config: appConfig;
    dispatch: (action: ACTION, message: unknown) => void;
    subscribe: (action: ACTION, fn: Function) => void;
    unsubscribe: (action: ACTION) => void;
}
export interface ISubScribeConfig {
    reserveCallBack: boolean;
}
